#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

#define MAX_MAPF_SIZE 255

#define MAX_MAP_XSIZE 200
#define MAX_MAP_YSIZE 200

// Map fields
int n_mapf_size=MAX_MAPF_SIZE;
struct s_mapf {
				unsigned char m; // Map field properties
				unsigned char c; // Char
				unsigned char f,b; // Foreground, background color
			  } mapf[255];

// Game map
int n_map_xsize=MAX_MAP_XSIZE;
int n_map_ysize=MAX_MAP_YSIZE;
struct s_map {
			   char name[64]; // Map name
			   unsigned char m[MAX_MAP_XSIZE][MAX_MAP_YSIZE]; // Map fields properties
			   //unsigned char p[MAX_MAP_XSIZE][MAX_MAP_YSIZE];
			 } map;

int map_mx=0, map_my=0;
unsigned char end_p=0;
unsigned char menu1=0;
unsigned char rdrw=0;
unsigned char debug_mode=0;
char ch;

unsigned char far *scr1=(unsigned char far *)MK_FP(0xb800,0);

// -------------------------------------------------------------------------

void putcxy(unsigned char ch1, unsigned char x1, unsigned char y1, unsigned char fc, unsigned char bc)
{
  scr1[(y1-1)*80*2+(x1-1)*2]=ch1;
  if (bc<8) { scr1[(y1-1)*80*2+(x1-1)*2+1]=bc*16+fc; }
	   else { scr1[(y1-1)*80*2+(x1-1)*2+1]=(bc-8)*16+fc; }
}

unsigned char mk_random_bkgchar()
{
  if (random(100)<60) { return (32+random(220)); }
				 else { return (32); }
}

void draw_map()
{
  int ix,iy;

  for (iy=0; iy<45; iy++)
  for (ix=0; ix<75; ix++)
  {
	//gotoxy((ix+1),(iy+4));
	if ( ((ix+map_mx)>=0) && ((iy+map_my)>=0)
	  && ((ix+map_mx)<n_map_xsize) && ((iy+map_my)<n_map_ysize) )
	{
	  if (mapf[ map.m[(ix+map_mx)][(iy+map_my)] ].c=='@')
	  {
		putcxy(mk_random_bkgchar(),(ix+1),(iy+4),8,0);
		/*
		textcolor(8);
		textbackground(0);
		cprintf("%c", mk_random_bkgchar());
		*/
	  }
	  else
	  {
		putcxy(mapf[ map.m[(ix+map_mx)][(iy+map_my)] ].c,(ix+1),(iy+4),mapf[ map.m[(ix+map_mx)][(iy+map_my)] ].f,mapf[ map.m[(ix+map_mx)][(iy+map_my)] ].b);
		/*
		textcolor(mapf[ map.m[(ix+map_mx)][(iy+map_my)] ].f);
		textbackground(mapf[ map.m[(ix+map_mx)][(iy+map_my)] ].b);
		cprintf("%c",mapf[ map.m[(ix+map_mx)][(iy+map_my)] ].c);
		*/
	  }
	}
	else
	{
	  putcxy('x',(ix+1),(iy+4),8,0);
	  /*
	  textcolor(8);
	  textbackground(0);
	  cprintf("x");
	  */
	}
  }
}

void init_map()
// Initialise testing map
{
  int ix,iy;

  // Map name
  strcpy(map.name,"Map1");

  // Initialise map fields
  for (iy=0; iy<n_map_ysize; iy++)
  for (ix=0; ix<n_map_xsize; ix++)
  {
	map.m[ix][iy]=0; // Clear all map fields

	// Create map borders
	if ( (ix==0) || (iy==0) || (ix==(n_map_xsize-1)) || (iy==(n_map_ysize-1)) )
	  {  map.m[ix][iy]=1;  }
  }
}

void init_mapf()
{
  // m=0 ... normal playing field
  // m=1 ... wall
  // m=2 ... tuneler playing filed
  // m=3 ... eat
  // m=4 ... CTF - flag - begin
  // m=5 ... CTF - flag - end

  int i1;
  unsigned char ch1,ch2;

  mapf[0].m= 0; mapf[0].f= 1; mapf[0].b= 1; mapf[0].c=' ';
  mapf[1].m= 1; mapf[1].f=14; mapf[1].b=14; mapf[1].c='';
  mapf[2].m= 2; mapf[2].f= 9; mapf[2].b= 1; mapf[2].c='';
  mapf[3].m= 3; mapf[3].f=10; mapf[3].b= 1; mapf[3].c='O';
  mapf[4].m= 1; mapf[4].f= 8; mapf[4].b= 0; mapf[4].c='@';

  // CTF
  mapf[5].m= 4; mapf[5].f=10; mapf[5].b= 7; mapf[5].c='';
  mapf[6].m= 5; mapf[6].f= 9; mapf[6].b= 7; mapf[6].c='';

  // Other objects
  mapf[7].m= 0; mapf[7].f= 7; mapf[7].b= 0; mapf[7].c='x';
  mapf[8].m= 0; mapf[8].f= 7; mapf[8].b= 0; mapf[8].c='x';
  mapf[9].m= 0; mapf[9].f= 7; mapf[9].b= 0; mapf[9].c='x';

  // Teleport
  for (i1=0; i1<10; i1++)
  {
	if (debug_mode==0)
	{
	  ch1='.';
	}
	else
	{
	  ch1=48+i1;
	}
	mapf[(i1+10)].m=i1+10; mapf[(i1+10)].f= 7; mapf[(i1+10)].b= 1; mapf[(i1+10)].c=ch1;
	mapf[(i1+20)].m=i1+20; mapf[(i1+20)].f= 7; mapf[(i1+20)].b= 1; mapf[(i1+20)].c=ch1;
  }

  // Moving rooms
  for (i1=0; i1<10; i1++)
  {
	if (debug_mode==0)
	{
	  ch1='';
	  ch2='';
	}
	else
	{
	  ch1='a'+i1;
	  ch2='A'+i1;
	}
	mapf[(i1+30)].m=i1+30; mapf[(i1+30)].f=14; mapf[(i1+30)].b= 1; mapf[(i1+30)].c=ch1;
	mapf[(i1+40)].m=i1+40; mapf[(i1+40)].f=14; mapf[(i1+40)].b= 1; mapf[(i1+40)].c=ch2;
  }

  n_mapf_size=50;
}

/*
void init_mapf_space()
{
  // m=0 ... normal playing field
  // m=1 ... wall
  // m=2 ... tuneler playing filed
  // m=3 ... eat
  // m=4 ... CTF - flag - begin
  // m=5 ... CTF - flag - end

  int i1;
  unsigned char ch1,ch2;

  mapf[0].m= 0; mapf[0].f= 8; mapf[0].b= 0; mapf[0].c='';
  mapf[1].m= 1; mapf[1].f= 7; mapf[1].b=15; mapf[1].c='';
  mapf[2].m= 2; mapf[2].f= 7; mapf[2].b= 0; mapf[2].c='';
  mapf[3].m= 3; mapf[3].f= 7; mapf[3].b= 1; mapf[3].c='O';
  mapf[4].m= 1; mapf[4].f= 8; mapf[4].b= 0; mapf[4].c='@';

  // CTF
  mapf[5].m= 4; mapf[5].f=10; mapf[5].b= 0; mapf[5].c='';
  mapf[6].m= 5; mapf[6].f= 9; mapf[6].b= 0; mapf[6].c='';

  // Other objects
  mapf[7].m= 0; mapf[7].f= 7; mapf[7].b= 0; mapf[7].c='x';
  mapf[8].m= 0; mapf[8].f= 7; mapf[8].b= 0; mapf[8].c='x';
  mapf[9].m= 0; mapf[9].f= 7; mapf[9].b= 0; mapf[9].c='x';

  // Teleport
  for (i1=0; i1<10; i1++)
  {
	if (debug_mode==0)
	{
	  ch1='';
	}
	else
	{
	  ch1=48+i1;
	}
	mapf[(i1+10)].m=i1+10; mapf[(i1+10)].f= 8; mapf[(i1+10)].b= 0; mapf[(i1+10)].c=ch1;
	mapf[(i1+20)].m=i1+20; mapf[(i1+20)].f= 8; mapf[(i1+20)].b= 0; mapf[(i1+20)].c=ch1;
  }

  // Moving rooms
  for (i1=0; i1<10; i1++)
  {
	if (debug_mode==0)
	{
	  ch1='';
	  ch2='';
	}
	else
	{
	  ch1='a'+i1;
	  ch2='A'+i1;
	}
	mapf[(i1+30)].m=i1+30; mapf[(i1+30)].f= 7; mapf[(i1+30)].b=15; mapf[(i1+30)].c=ch1;
	mapf[(i1+40)].m=i1+40; mapf[(i1+40)].f= 7; mapf[(i1+40)].b=15; mapf[(i1+40)].c=ch2;
  }

  n_mapf_size=50;
}
*/

void import_raw(int x1, int y1, char fname[])
{
  int i1,ix,iy;
  FILE *in;

  if ((in = fopen(fname, "rb")) == NULL)
  {
	 printf("Cannot open %s for reading.\n", fname);
  }
  else
  {
	for (iy=0; iy<y1; iy++)
	for (ix=0; ix<x1; ix++)
	{
	  i1=fgetc(in);
	  if ( (ix<n_map_xsize) && (iy<n_map_ysize) )
	  {
		map.m[ix][iy]=i1;
	  }
	}
	fclose(in);
  }
}

void load_map(char map_file[])
{
  int i1,i2,ix,iy;
  unsigned char chx;
  FILE *in;

  clreol();cprintf("\n\r");

  clreol(); cprintf("Map file name: %s\n\r", map_file);

  if ((in = fopen(map_file, "rb")) == NULL)
  {
	 clreol();
	 cprintf("Cannot open %s for reading.\n", map_file);
  }
  else
  {
	// Header
	clreol();
	cprintf("Map ID: ");
	for (i1=0; i1<5; i1++)
	{
	  chx=fgetc(in);
	  printf("%c", chx);
	}
	cprintf("\n\r");

	// Map name
	strcpy(map.name, "");
	for (i1=0; i1<32; i1++)
	{
	  chx=fgetc(in);
	  map.name[i1]=chx;
	}
	map.name[32]=0;
	clreol(); cprintf("Map name: %s\n\r", map.name);

	// Mapf size
	n_mapf_size=fgetc(in); // MAPF_SIZE

	clreol(); cprintf("mapf_size: %i\n\r", n_mapf_size);

	// Map size
	n_map_xsize=fgetc(in); // X_SIZE
	n_map_ysize=fgetc(in); // Y_SIZE

	clreol(); cprintf("x_size / max_x_size: %i / %i\n\r", n_map_xsize, MAX_MAP_XSIZE);
	clreol(); cprintf("y_size / max_y_size: %i / %i\n\r", n_map_ysize, MAX_MAP_YSIZE);

	// Players
	i2=fgetc(in); // Number of players
	for (i1=0; i1<i2; i1++)
	{
	  //pl[i1].x[0]=fgetc(in);
	  //pl[i1].y[0]=fgetc(in);
	  ix=fgetc(in);
	  iy=fgetc(in);
	}
	clreol(); printf("Players: %i\n\r", i2);

	for (i1=0; i1<n_mapf_size; i1++)
	{
	  mapf[i1].m=fgetc(in);
	  mapf[i1].c=fgetc(in);
	  mapf[i1].f=fgetc(in);
	  mapf[i1].b=fgetc(in);
	}

	if ( (n_map_xsize<=MAX_MAP_XSIZE) && (n_map_ysize<=MAX_MAP_YSIZE) )
	{
	  for (iy=0; iy<n_map_ysize; iy++)
	  for (ix=0; ix<n_map_xsize; ix++)
	  {
		map.m[ix][iy]=fgetc(in);
	  }

	  clreol(); cprintf("OK, map successfully loaded.\n\r");
	}
	else
	{
	  clreol(); cprintf("Map size is out of range.\n\r");
	}

	fclose(in);
  }

  clreol();cprintf("\n\r");
  clreol();cprintf("Press any key...");
  getch();
}

void save_map(char map_file[])
{
  int i1,i2;
  FILE *out;

  if ((out = fopen(map_file, "wb")) == NULL)
  {
	 clreol();
	 cprintf("Cannot open output file.\n\r");
  }
  else
  {
	fprintf(out, "PMF10");

	// Map name
	//               12345678901234567890123456789012
	strcpy(map.name,"-=          Test map          =-");
	fprintf(out,map.name);

	// Mapf size
	fputc(n_mapf_size, out);

	// Map size
	fputc(n_map_xsize, out);
	fputc(n_map_ysize, out);

	// Players
	fputc(4, out);
	fputc(5, out); fputc(5, out); // Player1
	fputc((n_map_xsize-7), out); fputc((n_map_ysize-7), out); // Player2
	fputc((n_map_xsize-7), out); fputc(5, out); // Player3
	fputc(5, out); fputc((n_map_ysize-7), out); // Player4

	for (i1=0; i1<n_mapf_size; i1++)
	{
	  fputc(mapf[i1].m, out);
	  fputc(mapf[i1].c, out);
	  fputc(mapf[i1].f, out);
	  fputc(mapf[i1].b, out);
	}

	for (i2=0; i2<n_map_ysize; i2++)
	{
	  for (i1=0; i1<n_map_xsize; i1++)
	  {
		fputc(map.m[i1][i2], out);
	  }
	}
	fclose(out);

	clreol(); cprintf("OK, map generated successfully.\n\r");
  }

  clreol();cprintf("\n\r");
  clreol();cprintf("Press any key...");
  getch();
}

// -------------------------------------------------------------------------

void show_menu()
{
  textcolor(7);
  textbackground(0);

  gotoxy (1,1);
  cprintf("Pizdjoski MapGen v2 - (%ix%i)             \n", n_map_xsize, n_map_ysize);
  gotoxy (1,2);
  clreol();
  textcolor(15);
  cprintf("[ %i - ", menu1);
  switch (menu1)
  {
	case 0 : cprintf("Load map"); break;
	case 1 : cprintf("Save map"); break;
	case 2 : cprintf("Import RAW"); break;
	case 3 : cprintf("Export RAW"); break;
	case 4 : cprintf("Change map size"); break;
   default : cprintf("Unknown command"); break;
  }
  cprintf(" ]           ");
}

void enter_menu()
{
  int i1,i2;
  char sx1[128];

  textcolor(7);
  textbackground(0);

  switch (menu1)
  {
	case 0 : gotoxy(1,3); clreol(); cprintf("Load map file name: "); scanf("%s",sx1);
			 gotoxy(1,3); clreol();
			 load_map(sx1);
			 rdrw=1;
			 break;

	case 1 : gotoxy(1,3); clreol(); cprintf("Save map file name: "); scanf("%s",sx1);
			 gotoxy(1,3); clreol();
			 save_map(sx1);
			 rdrw=1;
			 break;

	case 2 : gotoxy(1,3); clreol(); cprintf("Raw file name: "); scanf("%s",sx1);
			 gotoxy(1,4); clreol(); cprintf("X_SIZE: "); scanf("%i", &i1);
			 gotoxy(1,5); clreol(); cprintf("Y_SIZE: "); scanf("%i", &i2);
			 gotoxy(1,3); clreol();
			 import_raw(i1,i2,sx1);
			 rdrw=1;
			 break;

	case 4 : gotoxy(1,3); clreol(); cprintf("X_SIZE: "); scanf("%i", &n_map_xsize);
			 gotoxy(1,4); clreol(); cprintf("Y_SIZE: "); scanf("%i", &n_map_ysize);
			 gotoxy(1,3); clreol();
			 rdrw=1;
			 break;
  }
}

void main()
{
  textmode (C4350);
  clrscr();

  init_map();
  init_mapf();
  draw_map();
  show_menu();

  while (end_p==0)
  {
	ch=getch();
	switch (ch)
	{
	  case 27 : end_p=1; break; // ESC

	 case 'a' : menu1--; break;
	 case 'z' : menu1++; break;
	  case 13 : enter_menu(); break;

	 case 'r' : rdrw=1; break;

	   case 0 : ch=getch();
				switch (ch)
				{
				  case 72 : map_my=map_my-10; rdrw=1; break; // Up arrow
				  case 80 : map_my=map_my+10; rdrw=1; break; // Down arrow
				  case 75 : map_mx=map_mx-10; rdrw=1; break; // Left arrow
				  case 77 : map_mx=map_mx+10; rdrw=1; break; // Right arrow

				  /*
				  case 82 : change_numofpl(2); break; // INS
				  case 83 : change_numofpl(1); break; // DEL
				  case 71 : change_numofpl(3); break; // HOME
				  */
				}
				ch=0;
				break;
	}

	if (rdrw==1)
	{
	  rdrw=0;
	  draw_map();
	}
	show_menu();
  }
}

